#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <utility>
#include <algorithm>

using namespace std;

const long MOD=998244353;
const int MAX = 11000 ;

long f[MAX][MAX] ;
long X[MAX] ;
long Xsum[MAX] ;

long powmod(long b, long k) {
    if(k==0) return 1;
    if(k==1) return b%MOD;
    long ret = powmod(b, k/2);
    ret = (ret * ret)%MOD;
    if(k%2) ret = (ret * b)%MOD;
    return ret;
}

long modinv(long b) {
    return powmod(b, MOD-2);
}

long binom(long n, long k) {
    if(k==0) return 1;
    return ((binom(n-1,k-1) * n)%MOD * modinv(k))%MOD;
}

int main(void) {
    int N,T; cin >> N >> T;
    for(int i=0; i<N; i++) {
        cin >> X[i];
        Xsum[i+1] = (Xsum[i] + X[i])%MOD;
    }
    f[1][1]=1;
    for(int n=2; n<=N; n++) for(int g=1; g<=n+1; g++) {
        f[n][g] = (f[n-1][g-1] * (g-1))%MOD;
        for(int g2=g; g2<=n; g2++) f[n][g] = (f[n][g] + f[n-1][g2]*Xsum[n-1])%MOD;
    }
    long ret = 0;
    for(int g=1; g<=N+1; g++) {
        ret += f[N][g] * binom(T+g-Xsum[N], g-1);
        ret %= MOD;
    }
    ret = (ret * (T+1-Xsum[N]))%MOD;
    cout << ret << endl;
}
